diff --git src/VBox/Additions/common/VBoxGuest/VBoxGuest-netbsd.c src/VBox/Additions/common/VBoxGuest/VBoxGuest-netbsd.c
new file mode 100644
index 0000000..920b798
--- /dev/null
+++ src/VBox/Additions/common/VBoxGuest/VBoxGuest-netbsd.c
@@ -0,0 +1,597 @@
+/* $Id: VBoxGuest-netbsd.c $ */
+/** @file
+ * VirtualBox Guest Additions Driver for NetBSD.
+ */
+
+/*
+ * Copyright (C) 2007-2011 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ */
+
+/** @todo r=bird: This must merge with SUPDrv-netbsd.c before long. The two
+ * source files should only differ on prefixes and the extra bits wrt to the
+ * pci device. I.e. it should be diffable so that fixes to one can easily be
+ * applied to the other. */
+
+#include <sys/param.h>
+#include <sys/systm.h>
+#include <sys/select.h>
+#include <sys/conf.h>
+#include <sys/kernel.h>
+#include <sys/kmem.h>
+#include <sys/module.h>
+#include <sys/device.h>
+#include <sys/bus.h>
+#include <sys/poll.h>
+#include <sys/proc.h>
+#include <sys/stat.h>
+#include <sys/selinfo.h>
+#include <sys/queue.h>
+#include <sys/lock.h>
+#include <sys/types.h>
+#include <sys/conf.h>
+#include <sys/malloc.h>
+#include <sys/uio.h>
+#include <sys/file.h>
+#include <sys/filedesc.h>
+#include <sys/vfs_syscalls.h>
+#include <dev/pci/pcivar.h>
+#include <dev/pci/pcireg.h>
+#include <dev/pci/pcidevs.h>
+
+#ifdef PVM
+#  undef PVM
+#endif
+#include "VBoxGuestInternal.h"
+#include <VBox/log.h>
+#include <iprt/assert.h>
+#include <iprt/initterm.h>
+#include <iprt/process.h>
+#include <iprt/mem.h>
+#include <iprt/asm.h>
+
+/** The module name. */
+#define DEVICE_NAME    "vboxguest"
+
+typedef struct VBoxGuestDeviceState
+{
+    device_t sc_dev;
+    struct pci_attach_args *pa;
+    bus_space_tag_t io_tag;
+    bus_space_handle_t io_handle;
+    bus_addr_t uIOPortBase;
+    bus_size_t io_regsize;
+    bus_space_tag_t iVMMDevMemResId;
+    bus_space_handle_t VMMDevMemHandle;
+    bus_addr_t pMMIOBase;
+    bus_size_t VMMDevMemSize;
+
+    pci_intr_handle_t ih;
+    /** Pointer to the IRQ handler. */
+    void              *pfnIrqHandler;
+    /** Controller features, limits and status. */
+    u_int                   vboxguest_state;
+} vboxguest_softc;
+
+
+struct vboxguest_session
+{
+    vboxguest_softc *sc;
+    PVBOXGUESTSESSION       session;
+};
+
+#define VBOXGUEST_STATE_INITOK 1 << 0
+
+/*
+ * Character device file handlers.
+ */
+static int VBoxGuestNetBSDOpen(dev_t device, int flags, int fmt, struct lwp *process);
+static int VBoxGuestNetBSDClose(struct file *fp);
+static int VBoxGuestNetBSDIOCtl(struct file *fp, u_long cmd, void *addr);
+static int VBoxGuestNetBSDPoll(struct file *fp, int events);
+static void VBoxGuestNetBSDAttach(device_t, device_t, void*);
+static int VBoxGuestNetBSDDetach(device_t pDevice, int flags);
+
+/*
+ * IRQ related functions.
+ */
+static void VBoxGuestNetBSDRemoveIRQ(vboxguest_softc *sc);
+static int  VBoxGuestNetBSDAddIRQ(vboxguest_softc *pvState);
+static int  VBoxGuestNetBSDISR(void *pvState);
+
+/*
+ * Device node entry points.
+ */
+static struct cdevsw g_VBoxGuestNetBSDChrDevSW =
+{
+    VBoxGuestNetBSDOpen,
+    noclose,
+    noread,
+    nowrite,
+    noioctl,
+    nostop,
+    notty,
+    nopoll,
+    nommap,
+    nokqfilter,
+    nodiscard
+};
+
+static const struct fileops vboxguest_fileops = {
+	.fo_read = fbadop_read,
+	.fo_write = fbadop_write,
+	.fo_ioctl = VBoxGuestNetBSDIOCtl,
+	.fo_fcntl = fnullop_fcntl,
+	.fo_poll = VBoxGuestNetBSDPoll,
+	.fo_stat = fbadop_stat,
+	.fo_close = VBoxGuestNetBSDClose,
+	.fo_kqfilter = fnullop_kqfilter,
+	.fo_restart = fnullop_restart
+};
+
+/** Device extention & session data association structure. */
+static VBOXGUESTDEVEXT      g_DevExt;
+/** selinfo structure used for polling. */
+static struct selinfo       g_SelInfo;
+/** Reference counter */
+static volatile uint32_t    cUsers;
+
+CFDRIVER_DECL(vboxguest, DV_DULL, NULL);
+extern struct cfdriver vboxguest_cd;
+
+/**
+ * File open handler
+ *
+ */
+static int VBoxGuestNetBSDOpen(dev_t device, int flags, int fmt, struct lwp *process)
+{
+    int rc;
+    vboxguest_softc *vboxguest;
+    struct vboxguest_session *session;
+    file_t *fp;
+    int fd, error;
+
+    LogFlow((DEVICE_NAME ":VBoxGuestNetBSDOpen\n"));
+
+    if ((vboxguest = device_lookup_private(&vboxguest_cd, minor(device))) == NULL) {
+        printf("device_lookup_private failed\n");
+        return (ENXIO);
+    }
+    if ((vboxguest->vboxguest_state & VBOXGUEST_STATE_INITOK) == 0) {
+        aprint_error_dev(vboxguest->sc_dev, "device not configured\n");
+        return (ENXIO);
+    }
+
+    session = kmem_alloc(sizeof(*session), KM_SLEEP);
+    if (session == NULL) {
+        return (ENOMEM);
+    }
+
+    session->sc = vboxguest;
+
+    if ((error = fd_allocfile(&fp, &fd)) != 0) {
+        kmem_free(session, sizeof(*session));
+        return error;
+    }
+
+    /*
+     * Create a new session.
+     */
+    rc = VBoxGuestCreateUserSession(&g_DevExt, &session->session);
+    if (! RT_SUCCESS(rc))
+    {
+        aprint_error_dev(vboxguest->sc_dev, "VBox session creation failed\n");
+        closef(fp); /* ??? */
+        kmem_free(session, sizeof(*session));
+        return RTErrConvertToErrno(rc);
+    }
+    ASMAtomicIncU32(&cUsers);
+    return fd_clone(fp, fd, flags, &vboxguest_fileops, session);
+
+}
+
+/**
+ * File close handler
+ *
+ */
+static int VBoxGuestNetBSDClose(struct file *fp)
+{
+    struct vboxguest_session *session = fp->f_data;
+    vboxguest_softc *vboxguest = session->sc;
+
+    VBoxGuestCloseSession(&g_DevExt, session->session);
+    ASMAtomicDecU32(&cUsers);
+
+    kmem_free(session, sizeof(*session));
+
+    return 0;
+}
+
+/**
+ * IOCTL handler
+ *
+ */
+static int VBoxGuestNetBSDIOCtl(struct file *fp, u_long command, void *data)
+{
+    struct vboxguest_session *session = fp->f_data;
+    vboxguest_softc *vboxguest = session->sc;
+
+    int rc = 0;
+
+    /*
+     * Validate the request wrapper.
+     */
+    if (IOCPARM_LEN(command) != sizeof(VBGLBIGREQ)) {
+        Log((DEVICE_NAME ": VBoxGuestFreeBSDIOCtl: bad request %lu size=%lu expected=%d\n", command, IOCPARM_LEN(command), sizeof(VBGLBIGREQ)));
+        return ENOTTY;
+    }
+
+    PVBGLBIGREQ ReqWrap = (PVBGLBIGREQ)data;
+    if (ReqWrap->u32Magic != VBGLBIGREQ_MAGIC)
+    {
+        Log((DEVICE_NAME ": VBoxGuestNetBSDIOCtl: bad magic %#x; pArg=%p Cmd=%lu.\n", ReqWrap->u32Magic, data, command));
+        return EINVAL;
+    }
+    if (RT_UNLIKELY(   ReqWrap->cbData == 0
+                    || ReqWrap->cbData > _1M*16))
+    {
+        printf(DEVICE_NAME ": VBoxGuestNetBSDIOCtl: bad size %#x; pArg=%p Cmd=%lu.\n", ReqWrap->cbData, data, command);
+        return EINVAL;
+    }
+
+    /*
+     * Read the request.
+     */
+    void *pvBuf = RTMemTmpAlloc(ReqWrap->cbData);
+    if (RT_UNLIKELY(!pvBuf))
+    {
+        Log((DEVICE_NAME ":VBoxGuestNetBSDIOCtl: RTMemTmpAlloc failed to alloc %d bytes.\n", ReqWrap->cbData));
+        return ENOMEM;
+    }
+
+    rc = copyin((void *)(uintptr_t)ReqWrap->pvDataR3, pvBuf, ReqWrap->cbData);
+    if (RT_UNLIKELY(rc))
+    {
+        RTMemTmpFree(pvBuf);
+        Log((DEVICE_NAME ":VBoxGuestNetBSDIOCtl: copyin failed; pvBuf=%p pArg=%p Cmd=%lu. rc=%d\n", pvBuf, data, command, rc));
+aprint_error_dev(vboxguest->sc_dev, "copyin failed\n");
+        return EFAULT;
+    }
+    if (RT_UNLIKELY(   ReqWrap->cbData != 0
+                    && !VALID_PTR(pvBuf)))
+    {
+        RTMemTmpFree(pvBuf);
+        Log((DEVICE_NAME ":VBoxGuestNetBSDIOCtl: pvBuf invalid pointer %p\n", pvBuf));
+        return EINVAL;
+    }
+
+    /*
+     * Process the IOCtl.
+     */
+    size_t cbDataReturned;
+    rc = VBoxGuestCommonIOCtl(command, &g_DevExt, session->session, pvBuf, ReqWrap->cbData, &cbDataReturned);
+    if (RT_SUCCESS(rc)) {
+        rc = 0;
+        if (RT_UNLIKELY(cbDataReturned > ReqWrap->cbData))
+        {
+            Log((DEVICE_NAME ":VBoxGuestNetBSDIOCtl: too much output data %d expected %d\n", cbDataReturned, ReqWrap->cbData));
+            cbDataReturned = ReqWrap->cbData;
+        }
+        if (cbDataReturned > 0)
+        {
+            rc = copyout(pvBuf, (void *)(uintptr_t)ReqWrap->pvDataR3, cbDataReturned);
+            if (RT_UNLIKELY(rc))
+            {
+                Log((DEVICE_NAME ":VBoxGuestNetBSDIOCtl: copyout failed; pvBuf=%p pArg=%p. rc=%d\n", pvBuf, data, rc));
+            }
+        }
+    } else {
+        Log((DEVICE_NAME ":VBoxGuestNetBSDIOCtl: VBoxGuestCommonIOCtl failed. rc=%d\n", rc));
+        rc = -rc;
+    }
+    RTMemTmpFree(pvBuf);
+    return rc;
+}
+
+static int VBoxGuestNetBSDPoll(struct file *fp, int events)
+{
+    struct vboxguest_session *session = fp->f_data;
+    vboxguest_softc *vboxguest = session->sc;
+
+    int rc = 0;
+    int events_processed;
+
+    uint32_t u32CurSeq = ASMAtomicUoReadU32(&g_DevExt.u32MousePosChangedSeq);
+    if (session->session->u32MousePosChangedSeq != u32CurSeq) {
+        events_processed = events & (POLLIN | POLLRDNORM);
+        session->session->u32MousePosChangedSeq = u32CurSeq;
+    } else {
+        events_processed = 0;
+
+        selrecord(curlwp, &g_SelInfo);
+    }
+
+    return events_processed;
+}
+
+static int VBoxGuestNetBSDDetach(device_t self, int flags)
+{
+    vboxguest_softc *vboxguest;
+    vboxguest = device_private(self);
+
+    if (cUsers > 0)
+        return EBUSY;
+
+    if ((vboxguest->vboxguest_state & VBOXGUEST_STATE_INITOK) == 0) {
+        return 0;
+    }
+
+    /*
+     * Reverse what we did in VBoxGuestNetBSDAttach.
+     */
+
+    VBoxGuestNetBSDRemoveIRQ(vboxguest);
+
+    VBoxGuestDeleteDevExt(&g_DevExt);
+
+    RTR0Term();
+
+    return 0;
+}
+
+/**
+ * Interrupt service routine.
+ *
+ * @returns Whether the interrupt was from VMMDev.
+ * @param   pvState Opaque pointer to the device state.
+ */
+static int VBoxGuestNetBSDISR(void *pvState)
+{
+    LogFlow((DEVICE_NAME ":VBoxGuestNetBSDISR pvState=%p\n", pvState));
+
+    bool fOurIRQ = VBoxGuestCommonISR(&g_DevExt);
+
+    return fOurIRQ ? 0 : 1;
+}
+
+void VBoxGuestNativeISRMousePollEvent(PVBOXGUESTDEVEXT pDevExt)
+{
+    LogFlow((DEVICE_NAME "::NativeISRMousePollEvent:\n"));
+
+    /*
+     * Wake up poll waiters.
+     */
+    selnotify(&g_SelInfo, 0, 0);
+}
+
+/**
+ * Sets IRQ for VMMDev.
+ *
+ * @returns NetBSD error code.
+ * @param   pDevice  Pointer to the device info structure.
+ * @param   pvState  Pointer to the state info structure.
+ */
+static int VBoxGuestNetBSDAddIRQ(vboxguest_softc *vboxguest)
+{
+    int iResId = 0;
+    int rc = 0;
+    struct pci_attach_args *pa = vboxguest->pa;
+    const char *intrstr;
+    char intstrbuf[100];
+
+    if (pci_intr_map(pa, &vboxguest->ih)) {
+        aprint_error_dev(vboxguest->sc_dev, "couldn't map interrupt.\n");
+        return VERR_DEV_IO_ERROR;
+    }
+    intrstr = pci_intr_string(vboxguest->pa->pa_pc, vboxguest->ih,
+            intstrbuf, sizeof(intstrbuf));
+    aprint_normal_dev(vboxguest->sc_dev, "interrupting at %s\n", intrstr);
+    vboxguest->pfnIrqHandler = pci_intr_establish(vboxguest->pa->pa_pc, vboxguest->ih, IPL_BIO, VBoxGuestNetBSDISR, vboxguest);
+    if (vboxguest->pfnIrqHandler == NULL) {
+        aprint_error_dev(vboxguest->sc_dev, "couldn't establish interrupt\n");
+        return VERR_DEV_IO_ERROR;
+    }
+
+    return VINF_SUCCESS;
+}
+
+/**
+ * Removes IRQ for VMMDev.
+ *
+ * @param   pDevice  Pointer to the device info structure.
+ * @param   pvState  Opaque pointer to the state info structure.
+ */
+static void VBoxGuestNetBSDRemoveIRQ(vboxguest_softc *vboxguest)
+{
+    if (vboxguest->pfnIrqHandler)
+    {
+        pci_intr_disestablish(vboxguest->pa->pa_pc, vboxguest->pfnIrqHandler);
+    }
+}
+
+static void VBoxGuestNetBSDAttach(device_t parent, device_t self, void *aux)
+{
+    int rc = VINF_SUCCESS;
+    int iResId = 0;
+    vboxguest_softc *vboxguest;
+    struct pci_attach_args *pa = aux;
+    bus_space_tag_t iot, memt;
+    bus_space_handle_t ioh, memh;
+    bus_dma_segment_t seg;
+    int ioh_valid, memh_valid;
+
+    cUsers = 0;
+
+    aprint_normal(": VirtualBox Guest\n");
+
+    vboxguest = device_private(self);
+    vboxguest->sc_dev = self;
+
+    /*
+     * Initialize IPRT R0 driver, which internally calls OS-specific r0 init.
+     */
+    rc = RTR0Init(0);
+    if (RT_FAILURE(rc))
+    {
+        LogFunc(("RTR0Init failed.\n"));
+        aprint_error_dev(vboxguest->sc_dev, "RTR0Init failed\n");
+        return ;
+    }
+
+    vboxguest->pa = pa;
+
+    /*
+     * Allocate I/O port resource.
+     */
+    ioh_valid = (pci_mapreg_map(pa, PCI_MAPREG_START, PCI_MAPREG_TYPE_IO, 0, &vboxguest->io_tag, &vboxguest->io_handle, &vboxguest->uIOPortBase, &vboxguest->io_regsize) == 0);
+
+    if (ioh_valid)
+    {
+
+        /*
+         * Map the MMIO region.
+         */
+        memh_valid = (pci_mapreg_map(pa, PCI_MAPREG_START+4, PCI_MAPREG_TYPE_MEM, BUS_SPACE_MAP_LINEAR, &vboxguest->iVMMDevMemResId, &vboxguest->VMMDevMemHandle, &vboxguest->pMMIOBase, &vboxguest->VMMDevMemSize) == 0);
+        if (memh_valid)
+        {
+            /*
+             * Call the common device extension initializer.
+             */
+            rc = VBoxGuestInitDevExt(&g_DevExt, vboxguest->uIOPortBase,
+                    bus_space_vaddr(vboxguest->iVMMDevMemResId,
+                            vboxguest->VMMDevMemHandle),
+                                    vboxguest->VMMDevMemSize,
+#if ARCH_BITS == 64
+                                     VBOXOSTYPE_NetBSD_x64,
+#else
+                                     VBOXOSTYPE_NetBSD,
+#endif
+                                     VMMDEV_EVENT_MOUSE_POSITION_CHANGED);
+            if (RT_SUCCESS(rc))
+            {
+                /*
+                 * Add IRQ of VMMDev.
+                 */
+                rc = VBoxGuestNetBSDAddIRQ(vboxguest);
+                if (RT_SUCCESS(rc))
+                {
+                    vboxguest->vboxguest_state |= VBOXGUEST_STATE_INITOK;
+                    return ;
+                }
+                VBoxGuestDeleteDevExt(&g_DevExt);
+            } else {
+                aprint_error_dev(vboxguest->sc_dev, "init failed\n");
+            }
+        } else {
+            aprint_error_dev(vboxguest->sc_dev, "MMIO mapping failed\n");
+        }
+    } else {
+        aprint_error_dev(vboxguest->sc_dev, "IO mapping failed\n");
+    }
+
+    RTR0Term();
+    return ;
+}
+
+static int
+VBoxGuestNetBSDMatch(device_t parent, cfdata_t match, void *aux)
+{
+    const struct pci_attach_args *pa = aux;
+    if ((PCI_VENDOR(pa->pa_id) == VMMDEV_VENDORID)
+            && (PCI_PRODUCT(pa->pa_id) == VMMDEV_DEVICEID)) {
+        return 1;
+    } else {
+        return 2;
+    }
+}
+
+/* Common code that depend on g_DevExt. */
+#include "VBoxGuestIDC-unix.c.h"
+
+CFATTACH_DECL_NEW(vboxguest, sizeof(vboxguest_softc),
+    VBoxGuestNetBSDMatch, VBoxGuestNetBSDAttach, VBoxGuestNetBSDDetach, NULL);
+
+MODULE(MODULE_CLASS_DRIVER, vboxguest, "pci");
+
+static int loc[2] = {-1, -1};
+
+static const struct cfparent pspec = {
+	"pci", "pci", DVUNIT_ANY
+};
+
+static struct cfdata vboxguest_cfdata[] = {
+        {
+                .cf_name = "vboxguest",
+                .cf_atname = "vboxguest",
+                .cf_unit = 0,           /* Only unit 0 is ever used  */
+                .cf_fstate = FSTATE_STAR,
+                .cf_loc = loc,
+                .cf_flags = 0,
+                .cf_pspec = &pspec,
+        },
+        { NULL, NULL, 0, 0, NULL, 0, NULL }
+};
+
+static int
+vboxguest_modcmd(modcmd_t cmd, void *opaque)
+{
+    devmajor_t bmajor, cmajor;
+    int error;
+    register_t retval;
+
+    bmajor = cmajor = NODEVMAJOR;
+    switch (cmd) {
+        case MODULE_CMD_INIT:
+                error = config_cfdriver_attach(&vboxguest_cd);
+                if (error) {
+                    printf("config_cfdriver_attach failed: %d", error);
+                    break;
+                }
+                error = config_cfattach_attach(vboxguest_cd.cd_name, &vboxguest_ca);
+                if (error) {
+                    config_cfdriver_detach(&vboxguest_cd);
+                    printf("%s: unable to register cfattach\n", vboxguest_cd.cd_name);
+                    break;
+                }
+
+                error = config_cfdata_attach(vboxguest_cfdata, 1);
+                if (error) {
+                        printf("%s: unable to attach cfdata\n", vboxguest_cd.cd_name);
+                        config_cfattach_detach(vboxguest_cd.cd_name, &vboxguest_ca);
+                        config_cfdriver_detach(&vboxguest_cd);
+                        break;
+                }
+
+                error = devsw_attach("vboxguest", NULL, &bmajor, &g_VBoxGuestNetBSDChrDevSW, &cmajor);
+                
+                if (error == EEXIST)
+                        error = 0; /* maybe built-in ... improve eventually */
+                if (error)
+                        break;
+
+                error = do_sys_mknod(curlwp, "/dev/vboxguest", 0666|S_IFCHR, makedev(cmajor, 0), &retval, UIO_SYSSPACE);
+                if (error == EEXIST)
+                        error = 0;
+                break;
+        case MODULE_CMD_FINI:
+                error = config_cfdata_detach(vboxguest_cfdata);
+                if (error)
+                    break;
+                error = config_cfattach_detach(vboxguest_cd.cd_name, &vboxguest_ca);
+                if (error)
+                    break;
+                config_cfdriver_detach(&vboxguest_cd);
+                error = devsw_detach(NULL, &g_VBoxGuestNetBSDChrDevSW);
+                break;
+        default:
+                return ENOTTY;
+    }
+    return error;
+}
diff --git src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3Lib.cpp src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3Lib.cpp
index 7abe60e..70e7290 100644
--- src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3Lib.cpp
+++ src/VBox/Additions/common/VBoxGuestLib/VBoxGuestR3Lib.cpp
@@ -40,10 +40,11 @@
    || defined(RT_OS_FREEBSD) \
    || defined(RT_OS_HAIKU) \
    || defined(RT_OS_LINUX) \
+   || defined(RT_OS_NETBSD) \
    || defined(RT_OS_SOLARIS)
 # include <sys/types.h>
 # include <sys/stat.h>
-# if defined(RT_OS_DARWIN) || defined(RT_OS_LINUX) /** @todo check this on solaris+freebsd as well. */
+# if defined(RT_OS_DARWIN) || defined(RT_OS_LINUX) || defined(RT_OS_NETBSD) /** @todo check this on solaris+freebsd as well. */
 #  include <sys/ioctl.h>
 # endif
 # if defined(RT_OS_DARWIN)
@@ -252,7 +253,7 @@ static int vbglR3Init(const char *pszDeviceName)
 
 #else
 
-    /* The default implementation. (linux, solaris, freebsd, haiku) */
+    /* The default implementation. (linux, solaris, freebsd, haiku, netbsd) */
     RTFILE File;
     int rc = RTFileOpen(&File, pszDeviceName, RTFILE_O_READWRITE | RTFILE_O_OPEN | RTFILE_O_DENY_NONE);
     if (RT_FAILURE(rc))
@@ -394,7 +395,7 @@ int vbglR3DoIOCtl(unsigned iFunction, void *pvData, size_t cbData)
     return RTErrConvertFromOS2(rc);
 
 #else
-# if defined(RT_OS_SOLARIS) || defined(RT_OS_FREEBSD)
+# if defined(RT_OS_SOLARIS) || defined(RT_OS_FREEBSD) || defined(RT_OS_NETBSD)
     VBGLBIGREQ Hdr;
     Hdr.u32Magic = VBGLBIGREQ_MAGIC;
     Hdr.cbData = cbData;
@@ -413,7 +414,7 @@ int vbglR3DoIOCtl(unsigned iFunction, void *pvData, size_t cbData)
     NOREF(cbData);
 # endif
 
-# if defined(RT_OS_SOLARIS) || defined(RT_OS_FREEBSD) || defined(RT_OS_DARWIN) || defined(RT_OS_LINUX)
+# if defined(RT_OS_SOLARIS) || defined(RT_OS_FREEBSD) || defined(RT_OS_DARWIN) || defined(RT_OS_LINUX) || defined(RT_OS_NETBSD)
 #  ifdef VBOX_VBGLR3_XSERVER
     int rc = xf86ioctl((int)g_File, iFunction, pvData);
 #  else
diff --git src/VBox/Additions/common/VBoxService/VBoxServiceVMInfo.cpp src/VBox/Additions/common/VBoxService/VBoxServiceVMInfo.cpp
index d8dbe7c..929716f 100644
--- src/VBox/Additions/common/VBoxService/VBoxServiceVMInfo.cpp
+++ src/VBox/Additions/common/VBoxService/VBoxServiceVMInfo.cpp
@@ -47,7 +47,7 @@
 #  include <sys/sockio.h>
 #  include <net/if_arp.h>
 # endif
-# if defined(RT_OS_DARWIN) || defined(RT_OS_FREEBSD)
+# if defined(RT_OS_DARWIN) || defined(RT_OS_FREEBSD) || defined(RT_OS_NETBSD)
 #  include <ifaddrs.h> /* getifaddrs, freeifaddrs */
 #  include <net/if_dl.h> /* LLADDR */
 #  include <netdb.h> /* getnameinfo */
@@ -1015,7 +1015,7 @@ static int vboxserviceVMInfoWriteNetwork(void)
     /** @todo Haiku: implement network info. retreival */
     return VERR_NOT_IMPLEMENTED;
 
-#elif defined(RT_OS_DARWIN) || defined(RT_OS_FREEBSD)
+#elif defined(RT_OS_DARWIN) || defined(RT_OS_FREEBSD) || defined(RT_OS_NETBSD)
     struct ifaddrs *pIfHead = NULL;
 
     /* Get all available interfaces */
diff --git src/VBox/Additions/common/crOpenGL/Makefile.kmk src/VBox/Additions/common/crOpenGL/Makefile.kmk
index 1827856..e0fd6c3 100644
--- src/VBox/Additions/common/crOpenGL/Makefile.kmk
+++ src/VBox/Additions/common/crOpenGL/Makefile.kmk
@@ -31,7 +31,7 @@ DLLS.win += \
     VBoxOGLpackspu \
     VBoxOGLfeedbackspu
 
-if1of ($(KBUILD_TARGET), linux solaris freebsd)
+if1of ($(KBUILD_TARGET), linux solaris freebsd netbsd)
 DLLS += \
     VBoxOGL \
     VBoxOGLarrayspu \
@@ -51,7 +51,7 @@ ifdef VBOX_WITH_WDDM
  DLLS.win.amd64 += $(VBOX_OGL_X86_GUEST_DLLS)
 endif
 
-if1of ($(KBUILD_TARGET), linux solaris freebsd)
+if1of ($(KBUILD_TARGET), linux solaris freebsd netbsd)
  #VBoxOGL_DRI = 1
  ifn1of ($(KBUILD_TARGET),solaris)   # No DRI on Solaris yet
   VBoxOGL_FAKEDRI = 1
@@ -60,7 +60,7 @@ if1of ($(KBUILD_TARGET), linux solaris freebsd)
  # Only Solaris right now needs C stubs because I can't figure out how to
  # generate the GOT based relocation ASM yet.
  ifdef VBoxOGL_FAKEDRI
-  if1of ($(KBUILD_TARGET).$(KBUILD_TARGET_ARCH),solaris.x86 solaris.amd64 linux.x86 linux.amd64 freebsd.x86 freebsd.amd64)
+  if1of ($(KBUILD_TARGET).$(KBUILD_TARGET_ARCH),solaris.x86 solaris.amd64 linux.x86 linux.amd64 freebsd.x86 freebsd.amd64 netbsd.x86 netbsd.amd64)
    VBOX_OGL_GLX_USE_CSTUBS = 1
   endif
  endif
@@ -72,7 +72,7 @@ endif
 #
 VBoxOGL_TEMPLATE       = VBOXCROGLR3GUESTDLL
 VBoxOGL_INCS           = .
-if1of ($(KBUILD_TARGET), linux solaris freebsd)
+if1of ($(KBUILD_TARGET), linux solaris freebsd netbsd)
  VBoxOGL_INCS     += \
 	$(VBOX_PATH_X11_ROOT)/libXdamage-1.1 \
 	$(VBOX_PATH_X11_ROOT)/libXcomposite-0.4.0 \
@@ -127,7 +127,7 @@ VBoxOGL_SOURCES       += \
 	$(VBOX_PATH_CROGL_GENFILES)/NULLfuncs.c \
 	$(VBOX_PATH_CROGL_GENFILES)/tsfuncs.c
 
-if1of ($(KBUILD_TARGET), linux solaris freebsd)
+if1of ($(KBUILD_TARGET), linux solaris freebsd netbsd)
  VBoxOGL_SOURCES += \
 	glx.c \
 	xfont.c
@@ -145,6 +145,8 @@ if1of ($(KBUILD_TARGET), linux solaris freebsd)
  	$(VBOX_PATH_CROGL_GENFILES)/solaris_exports_dri.asm
   VBoxOGL_SOURCES.freebsd += \
  	$(VBOX_PATH_CROGL_GENFILES)/freebsd_exports_dri.asm
+  VBoxOGL_SOURCES.netbsd += \
+ 	$(VBOX_PATH_CROGL_GENFILES)/netbsd_exports_dri.asm
  else ifdef VBoxOGL_FAKEDRI
   VBoxOGL_SOURCES += \
  	fakedri_drv.c
@@ -158,6 +160,9 @@ if1of ($(KBUILD_TARGET), linux solaris freebsd)
    VBoxOGL_SOURCES.freebsd += \
  	$(VBOX_PATH_CROGL_GENFILES)/freebsd_glxapi_exports.asm \
  	$(VBOX_PATH_CROGL_GENFILES)/freebsd_exports_dri.asm
+   VBoxOGL_SOURCES.netbsd += \
+ 	$(VBOX_PATH_CROGL_GENFILES)/netbsd_glxapi_exports.asm \
+ 	$(VBOX_PATH_CROGL_GENFILES)/netbsd_exports_dri.asm
   else
    VBoxOGL_SOURCES.solaris += \
   	$(VBOX_PATH_CROGL_GENFILES)/solaris_exports.c
@@ -165,6 +170,8 @@ if1of ($(KBUILD_TARGET), linux solaris freebsd)
   	$(VBOX_PATH_CROGL_GENFILES)/linux_exports.c
   VBoxOGL_SOURCES.freebsd += \
   	$(VBOX_PATH_CROGL_GENFILES)/freebsd_exports.c
+  VBoxOGL_SOURCES.netbsd += \
+  	$(VBOX_PATH_CROGL_GENFILES)/netbsd_exports.c
   endif
  else
   VBoxOGL_SOURCES.linux += \
@@ -173,6 +180,8 @@ if1of ($(KBUILD_TARGET), linux solaris freebsd)
   	$(VBOX_PATH_CROGL_GENFILES)/solaris_exports.c
   VBoxOGL_SOURCES.freebsd += \
   	$(VBOX_PATH_CROGL_GENFILES)/freebsd_exports.c
+  VBoxOGL_SOURCES.netbsd += \
+  	$(VBOX_PATH_CROGL_GENFILES)/netbsd_exports.c
  endif
 endif
 
@@ -213,14 +222,14 @@ VBoxOGL_LIBS = \
 	$(VBOX_LIB_VBGL_R3_SHARED) \
 	$(VBOX_LIB_OGL_CRUTIL) \
 	$(PATH_STAGE_LIB)/additions/VBoxOGLspuload$(VBOX_SUFF_LIB)
-if1of ($(KBUILD_TARGET), linux solaris freebsd)
+if1of ($(KBUILD_TARGET), linux solaris freebsd netbsd)
  VBoxOGL_LIBS += \
  	$(PATH_STAGE_LIB)/libXcomposite.so \
  	$(PATH_STAGE_LIB)/libXdamage.so \
  	$(PATH_STAGE_LIB)/libXfixes.so \
  	$(PATH_STAGE_LIB)/libXext.so
  ifdef VBoxOGL_FAKEDRI
-  ifeq ($(KBUILD_TARGET), freebsd)
+  if1of ($(KBUILD_TARGET), freebsd netbsd)
     VBoxOGL_LIBS += \
         elf
   else
@@ -301,8 +310,8 @@ $(VBOX_PATH_CROGL_GENFILES)/cropengl-x86.def: $(PATH_SUB_CURRENT)/defs.py $(VBOX
  endif #ifdef VBOX_WITH_WDDM
 
 
-else if1of ($(KBUILD_TARGET), freebsd linux solaris)
- # FreeBSD, Linux, Solaris
+else if1of ($(KBUILD_TARGET), freebsd linux netbsd solaris)
+ # FreeBSD, Linux, NetBSD, Solaris
 $(VBOX_PATH_CROGL_GENFILES)/getprocaddress.c: $(PATH_SUB_CURRENT)/getprocaddress.py $(VBOX_CROGL_API_FILES) | $$(dir $$@)
 	$(call MSG_GENERATE,python,$@,$<)
 	$(QUIET)$(call VBOX_CROGL_PYTHON_ENV,$(VBOX_PATH_CROGL_PYTHON_INCLUDE),$@) $(VBOX_BLD_PYTHON) $< $(VBOX_PATH_CROGL_GLAPI)
@@ -324,6 +333,14 @@ $(VBOX_PATH_CROGL_GENFILES)/freebsd_exports.c: \
 	$(call MSG_GENERATE,python,$@,$<)
 	$(QUIET)$(call VBOX_CROGL_PYTHON_ENV,$(VBOX_PATH_CROGL_PYTHON_INCLUDE),$@) $(VBOX_BLD_PYTHON) $< $(VBOX_PATH_CROGL_GLAPI)
 
+  else ifeq ($(KBUILD_TARGET),netbsd)
+$(VBOX_PATH_CROGL_GENFILES)/netbsd_exports.c: \
+		$(PATH_SUB_CURRENT)/NetBSD_exports.py \
+		$(VBOX_CROGL_API_FILES) $(PATH_SUB_CURRENT)/entrypoints.py \
+		| $$(dir $$@)
+	$(call MSG_GENERATE,python,$@,$<)
+	$(QUIET)$(call VBOX_CROGL_PYTHON_ENV,$(VBOX_PATH_CROGL_PYTHON_INCLUDE),$@) $(VBOX_BLD_PYTHON) $< $(VBOX_PATH_CROGL_GLAPI)
+
   else
 $(VBOX_PATH_CROGL_GENFILES)/linux_exports.asm: \
 		$(PATH_SUB_CURRENT)/Linux_i386_exports.py \
@@ -362,6 +379,14 @@ $(VBOX_PATH_CROGL_GENFILES)/freebsd_exports_dri.asm: \
 	$(call MSG_GENERATE,python,$@,$<)
 	$(QUIET)$(call VBOX_CROGL_PYTHON_ENV,$(VBOX_PATH_CROGL_PYTHON_INCLUDE),$@) $(VBOX_BLD_PYTHON) $< $(VBOX_PATH_CROGL_GLAPI)
 
+  else ifeq ($(KBUILD_TARGET),netbsd)
+$(VBOX_PATH_CROGL_GENFILES)/netbsd_exports_dri.asm: \
+		$(PATH_SUB_CURRENT)/NetBSD_i386_exports_dri.py \
+		$(VBOX_CROGL_API_FILES) $(PATH_SUB_CURRENT)/entrypoints.py \
+		| $$(dir $$@)
+	$(call MSG_GENERATE,python,$@,$<)
+	$(QUIET)$(call VBOX_CROGL_PYTHON_ENV,$(VBOX_PATH_CROGL_PYTHON_INCLUDE),$@) $(VBOX_BLD_PYTHON) $< $(VBOX_PATH_CROGL_GLAPI)
+
   else
 $(VBOX_PATH_CROGL_GENFILES)/linux_exports_dri.asm: \
 		$(PATH_SUB_CURRENT)/Linux_i386_exports_dri.py \
@@ -416,6 +441,15 @@ $(VBOX_PATH_CROGL_GENFILES)/freebsd_exports.c: \
 		| $$(dir $$@)
 	$(call MSG_GENERATE,python,$@,$<)
 	$(QUIET)$(call VBOX_CROGL_PYTHON_ENV,$(VBOX_PATH_CROGL_PYTHON_INCLUDE),$@) $(VBOX_BLD_PYTHON) $< $(VBOX_PATH_CROGL_GLAPI)
+
+  else ifeq ($(KBUILD_TARGET),netbsd)
+$(VBOX_PATH_CROGL_GENFILES)/netbsd_exports.c: \
+		$(PATH_SUB_CURRENT)/NetBSD_exports.py \
+		$(VBOX_CROGL_API_FILES) $(PATH_SUB_CURRENT)/entrypoints.py \
+		| $$(dir $$@)
+	$(call MSG_GENERATE,python,$@,$<)
+	$(QUIET)$(call VBOX_CROGL_PYTHON_ENV,$(VBOX_PATH_CROGL_PYTHON_INCLUDE),$@) $(VBOX_BLD_PYTHON) $< $(VBOX_PATH_CROGL_GLAPI)
+
   else
 $(VBOX_PATH_CROGL_GENFILES)/linux_exports.c: \
 		$(PATH_SUB_CURRENT)/Linux_exports.py \
@@ -435,7 +469,7 @@ endif
 VBoxOGLarrayspu_TEMPLATE      = VBOXCROGLR3GUESTDLL
 VBoxOGLarrayspu_INCS          = \
 	array
-if1of ($(KBUILD_TARGET), linux solaris freebsd)
+if1of ($(KBUILD_TARGET), linux solaris freebsd netbsd)
  VBoxOGLarrayspu_INCS += \
         $(VBOX_MESA_INCS)
 endif
@@ -483,7 +517,7 @@ endif
 VBoxOGLpassthroughspu_TEMPLATE    = VBOXCROGLR3GUESTDLL
 VBoxOGLpassthroughspu_INCS        = \
 	passthrough
-if1of ($(KBUILD_TARGET), linux solaris freebsd)
+if1of ($(KBUILD_TARGET), linux solaris freebsd netbsd)
  VBoxOGLpassthroughspu_INCS += \
         $(VBOX_MESA_INCS)
 endif
@@ -532,7 +566,7 @@ VBoxOGLpackspu_TEMPLATE      = VBOXCROGLR3GUESTDLL
 VBoxOGLpackspu_DEFS          = TRACKS_STATE=1 PACKS=1
 VBoxOGLpackspu_INCS          = \
 	pack
-if1of ($(KBUILD_TARGET), linux solaris freebsd)
+if1of ($(KBUILD_TARGET), linux solaris freebsd netbsd)
  VBoxOGLpackspu_INCS += \
         $(VBOX_MESA_INCS)
 endif
@@ -631,7 +665,7 @@ $(VBOX_PATH_CROGL_GENFILES)/packspu_proto.h: $(addprefix $(PATH_SUB_CURRENT)/pac
 VBoxOGLfeedbackspu_TEMPLATE    = VBOXCROGLR3GUESTDLL
 VBoxOGLfeedbackspu_INCS        = \
 	feedback
-if1of ($(KBUILD_TARGET), linux solaris freebsd)
+if1of ($(KBUILD_TARGET), linux solaris freebsd netbsd)
  VBoxOGLfeedbackspu_INCS += \
         $(VBOX_MESA_INCS)
 endif
diff --git src/VBox/Additions/common/crOpenGL/NetBSD_exports.py src/VBox/Additions/common/crOpenGL/NetBSD_exports.py
new file mode 100644
index 0000000..8f63e0a
--- /dev/null
+++ src/VBox/Additions/common/crOpenGL/NetBSD_exports.py
@@ -0,0 +1,11 @@
+# Copyright (c) 2001, Stanford University
+# All rights reserved.
+#
+# See the file LICENSE.txt for information on redistributing this software.
+
+import entrypoints
+
+hacks = []
+
+entrypoints.GenerateEntrypoints(hacks)
+
